/**
---------------------------------------------------------------------------

Copyright (c) 2009 Dan Simpson

Auto-Generated @ Wed Aug 26 19:21:28 -0700 2009.  Do not edit this file, extend it you must.

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

---------------------------------------------------------------------------
**/

/*
Documentation

    This method requests an access ticket for an access realm.
    The server responds by granting the access ticket.  If the
    client does not have access rights to the requested realm
    this causes a connection exception.  Access tickets are a
    per-channel resource.
  
*/
package org.ds.amqp.protocol.access
{
	import flash.utils.ByteArray;
	import org.ds.amqp.datastructures.*;
	import org.ds.amqp.protocol.Method;
	import org.ds.amqp.transport.Buffer;
	
	public dynamic class AccessRequest extends Method
	{
		public static var EVENT:String = "30/10";

		//
		public var realm                   :String = "";

		//
		public var exclusive               :Boolean = false;

		//
		public var passive                 :Boolean = false;

		//
		public var active                  :Boolean = false;

		//
		public var write                   :Boolean = false;

		//
		public var read                    :Boolean = false;

		
		public function AccessRequest() {
			_classId  = 30;
			_methodId = 10;
			
			_synchronous = true;

			_responses = [AccessRequestOk];

		}


		public override function writeArguments(buf:Buffer):void {

			buf.writeShortString(this.realm);
			buf.writeBit(this.exclusive);
			buf.writeBit(this.passive);
			buf.writeBit(this.active);
			buf.writeBit(this.write);
			buf.writeBit(this.read);
		}
		
		public override function readArguments(buf:Buffer):void {

			this.realm            = buf.readShortString();
			this.exclusive        = buf.readBit();
			this.passive          = buf.readBit();
			this.active           = buf.readBit();
			this.write            = buf.readBit();
			this.read             = buf.readBit();
		}
		
		public override function print():void {
			var props:Array = [
				"realm","exclusive","passive","active","write","read"
			];
			printObj("AccessRequest", props);
		}

	}
}