/**
---------------------------------------------------------------------------

Copyright (c) 2009 Dan Simpson

Auto-Generated @ Wed Aug 26 19:21:28 -0700 2009.  Do not edit this file, extend it you must.

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

---------------------------------------------------------------------------
**/

/*
Documentation

    This method requests a specific quality of service.  The QoS can
    be specified for the current channel or for all channels on the
    connection.  The particular properties and semantics of a qos method
    always depend on the content class semantics.  Though the qos method
    could in principle apply to both peers, it is currently meaningful
    only for the server.
  
*/
package org.ds.amqp.protocol.basic
{
	import flash.utils.ByteArray;
	import org.ds.amqp.datastructures.*;
	import org.ds.amqp.protocol.Method;
	import org.ds.amqp.transport.Buffer;
	
	public dynamic class BasicQos extends Method
	{
		public static var EVENT:String = "60/10";

		//
		public var prefetchSize            :uint = 0;

		//
		public var prefetchCount           :uint = 0;

		//
		public var global                  :Boolean = false;

		
		public function BasicQos() {
			_classId  = 60;
			_methodId = 10;
			
			_synchronous = true;

			_responses = [BasicQosOk];

		}


		public override function writeArguments(buf:Buffer):void {

			buf.writeLongInt(this.prefetchSize);
			buf.writeShortInt(this.prefetchCount);
			buf.writeBit(this.global);
		}
		
		public override function readArguments(buf:Buffer):void {

			this.prefetchSize     = buf.readLongInt();
			this.prefetchCount    = buf.readShortInt();
			this.global           = buf.readBit();
		}
		
		public override function print():void {
			var props:Array = [
				"prefetchSize","prefetchCount","global"
			];
			printObj("BasicQos", props);
		}

	}
}