/**
---------------------------------------------------------------------------

Copyright (c) 2009 Dan Simpson

Auto-Generated @ Wed Aug 26 19:21:28 -0700 2009.  Do not edit this file, extend it you must.

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.

---------------------------------------------------------------------------
**/

/*
Documentation

    This method binds a queue to an exchange.  Until a queue is
    bound it will not receive any messages.  In a classic messaging
    model, store-and-forward queues are bound to a dest exchange
    and subscription queues are bound to a dest_wild exchange.
  
*/
package org.ds.amqp.protocol.queue
{
	import flash.utils.ByteArray;
	import org.ds.amqp.datastructures.*;
	import org.ds.amqp.protocol.Method;
	import org.ds.amqp.transport.Buffer;
	
	public dynamic class QueueBind extends Method
	{
		public static var EVENT:String = "50/20";

		//
		public var ticket                  :uint = 0;

		//
		public var queue                   :String = "";

		//
		public var exchange                :String = "";

		//
		public var routingKey              :String = "";

		//
		public var nowait                  :Boolean = false;

		//
		public var arguments               :FieldTable = new FieldTable();

		
		public function QueueBind() {
			_classId  = 50;
			_methodId = 20;
			
			_synchronous = true;

			_responses = [QueueBindOk];

		}


		public override function writeArguments(buf:Buffer):void {

			buf.writeShortInt(this.ticket);
			buf.writeShortString(this.queue);
			buf.writeShortString(this.exchange);
			buf.writeShortString(this.routingKey);
			buf.writeBit(this.nowait);
			buf.writeTable(this.arguments);
		}
		
		public override function readArguments(buf:Buffer):void {

			this.ticket           = buf.readShortInt();
			this.queue            = buf.readShortString();
			this.exchange         = buf.readShortString();
			this.routingKey       = buf.readShortString();
			this.nowait           = buf.readBit();
			this.arguments        = buf.readTable();
		}
		
		public override function print():void {
			var props:Array = [
				"ticket","queue","exchange","routingKey","nowait","arguments"
			];
			printObj("QueueBind", props);
		}

	}
}